/*
 * HealthcardIO - a library providing functionality for accessing healthcards
 *
 * Copyright (C) 2017  gematik - Gesellschaft für Telematikanwendungen der Gesundheitskarte mbH
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.gematik.security.test;

import de.gematik.security.card2server.Client;
import de.gematik.security.iso7816.Iso7816UnsuccessfulExecutionException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.junit.Test;

import javax.smartcardio.CardException;

/**
 * @author André Szdzuy
 */
public class Card2ServerTest extends NfcBaseTest {
    private static final Log LOG = LogFactory.getLog(Card2ServerTest.class);

//    @Test
//    public void testWithoutServer() throws CardException, Iso7816UnsuccessfulExecutionException {
//        LOG.info("testWithoutServer()");
//
//        try {
//            HealthcardContext server = new HealthcardContext(new ServerChannel(), true);
//
//            byte[] iccsnEGK = healthcardContext.readICCSN();
//            LOG.info("iccsnEGK: " + Utilities.ByteArrayToSpacedHexString(iccsnEGK));
//
//            // GET CHALLENGE -> card
//            ResponseAPDU responseAPDU = healthcardContext.getChannel().transmit(new CommandAPDU(0x00, 0x84, 0x00, 0x00, 0x10));
//            healthcardContext.assertResponseStatus(responseAPDU, Constants.APDU_RESPONSE_OK);
//            byte[] rnd1 = responseAPDU.getData();
//            LOG.info("rnd1: " + Utilities.ByteArrayToSpacedHexString(rnd1));
//
//            // MSE SET -> server (select key for INTERNAL AUTHENTICATE)
//            String keyRef = Utilities.toHexString(0x00 | 0x19);   // location = 0x00, identifier = 0x19
//            String algId = "54";    // aesSessionkey4SM (MF/ SK.VSD.AES256)
//            server.manageSE("83 01", keyRef, algId, 0x41, 0xA4);
//
//            // construct input for INTERNAL AUTHENTICATE from rnd1 and iccsnEGK
//            // iccsnEGK has 12 bytes, but we only append its last 8 bytes to rnd1
//            byte[] iaInput = new byte[rnd1.length + 8];
//            System.arraycopy(rnd1, 0, iaInput, 0, rnd1.length);
//            System.arraycopy(iccsnEGK, 4, iaInput, rnd1.length, 8);
//
//            // INTERNAL AUTHENTICATE -> server
//            responseAPDU = server.getChannel().transmit(new CommandAPDU(0x00, 0x88, 0x00, 0x00, iaInput, 0x10000));
//            server.assertResponseStatus(responseAPDU, Constants.APDU_RESPONSE_OK);
//            byte[] iaOutput = responseAPDU.getData();
//
//            // MSE SET -> card (select key for MUTUAL AUTHENTICATE)
//            keyRef = Utilities.toHexString(0x00 | 0x19);   // location = 0x00, identifier = 0x19
//            algId = "54";    // aesSessionkey4SM (MF/ SK.VSD.AES256)
//            healthcardContext.manageSE("83 01", keyRef, algId, 0x81, 0xA4);
//
//            // MUTUAL AUTHENTICATE -> card
//            responseAPDU = healthcardContext.getChannel().transmit(new CommandAPDU(0x00, 0x82, 0x00, 0x00, iaOutput, 0x100));
//            healthcardContext.assertResponseStatus(responseAPDU, Constants.APDU_RESPONSE_OK);
//            byte[] maOutput = responseAPDU.getData();
//
//            // MSE SET -> server (select key for EXTERNAL AUTHENTICATE)
//            keyRef = Utilities.toHexString(0x00 | 0x19);   // location = 0x00, identifier = 0x19
//            algId = "54";    // aesSessionkey4SM (MF/ SK.VSD.AES256)
//            server.manageSE("83 01", keyRef, algId, 0x81, 0xA4);
//
//            // EXTERNAL AUTHENTICATE -> server
//            responseAPDU = server.getChannel().transmit(new CommandAPDU(0x00, 0x82, 0x00, 0x00, maOutput));
//            server.assertResponseStatus(responseAPDU, Constants.APDU_RESPONSE_OK);
//
//            // test write access to "Geschütze" VSD in order to verify the success of Card2Server authentication:
//
//            SecureMessaging secureMessaging = ((ServerChannel) server.getChannel()).getSecureMessaging();
//
//            CommandAPDU command;
//            byte[] commandBytes;
//
//            //SELECT DF.HCA
////            healthcardContext.selectADF("D27600000102");
//            command = new CommandAPDU(0x00, 0xA4, 0x04, 0xC, Utilities.HexStringToByteArray("D27600000102"));
//            LOG.info("command before secureMessaging.wrap:");
//            Utilities.logCommandAPDU(command);
//
//            commandBytes = command.getBytes();
//            commandBytes[0] = healthcardContext.adjustChannel(commandBytes[0]);
//            command = new CommandAPDU(commandBytes);
//
//            command = secureMessaging.wrap(command);
//            LOG.info("command after secureMessaging.wrap:");
//            Utilities.logCommandAPDU(command);
//            responseAPDU = healthcardContext.getChannel().transmit(command);
//            responseAPDU = secureMessaging.unwrap(responseAPDU);
//            healthcardContext.assertResponseStatus(responseAPDU, Constants.APDU_RESPONSE_OK);
//
//            //SELECT EF.StatusVD
////            healthcardContext.selectEF("D00C");
//            command = new CommandAPDU(0x00, 0xA4, 0x02, 0xC, Utilities.HexStringToByteArray("D00C"));
//            LOG.info("command before secureMessaging.wrap:");
//            Utilities.logCommandAPDU(command);
//
//            commandBytes = command.getBytes();
//            commandBytes[0] = healthcardContext.adjustChannel(commandBytes[0]);
//            command = new CommandAPDU(commandBytes);
//
//            command = secureMessaging.wrap(command);
//            LOG.info("command after secureMessaging.wrap:");
//            Utilities.logCommandAPDU(command);
//            responseAPDU = healthcardContext.getChannel().transmit(command);
//            responseAPDU = secureMessaging.unwrap(responseAPDU);
//            healthcardContext.assertResponseStatus(responseAPDU, Constants.APDU_RESPONSE_OK);
//        } catch (Exception e) {
//            LOG.error(e.getMessage());
//            throw new CardException(e);
//        }
//    }

    @Test
    public void testWithServer() throws CardException, Iso7816UnsuccessfulExecutionException {
        LOG.info("testWithServer()");

        Client client = new Client(healthcardContext, "http://lnl07.lab.gematik.de:8085");
        client.updateVSDM();
    }

}
