/*
 * HealthcardIO - a library providing functionality for accessing healthcards
 *
 * Copyright (C) 2017  gematik - Gesellschaft für Telematikanwendungen der Gesundheitskarte mbH
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.gematik.security.test;

import de.gematik.security.Utilities.CardFileSystem;
import de.gematik.security.crypto.HealthcardSignatureProvider;
import de.gematik.security.impl.HealthcardContext;
import org.spongycastle.jce.provider.BouncyCastleProvider;

import javax.smartcardio.Card;
import java.security.Security;

/**
 * @author André Szdzuy
 */
public class NfcBaseTest {

    static {
        Security.insertProviderAt(new BouncyCastleProvider(), 1);
        Security.addProvider(new HealthcardSignatureProvider());
    }

    protected static Card nfcCard = null;
    protected static HealthcardContext healthcardContext = null;
    protected static CardFileSystem cfs = null;
    protected static String cardTerminalName = null;

    public NfcBaseTest() {
        super();
    }

}
